package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class MathStaticMethodsTest {

	@Test
	public void test_abs() {
		assertEquals(10, Math.abs(10));

		assertEquals(20, Math.abs(-20));
	}

	@Test
	public void test_ceil() {
		assertEquals(8.0, Math.ceil(7.343), 0);
	}

	@Test
	public void test_floor() {
		assertEquals(7.0, Math.floor(7.343), 0);
	}

	@Test
	public void test_min() {
		assertEquals(8, Math.min(8, 17.343), 0);
	}

	@Test
	public void test_max() {
		assertEquals(17.343, Math.max(8, 17.343), 0);
	}

	@Test
	public void test_pow() {
		assertEquals(9, Math.pow(3, 2), 0);
	}

	@Test
	public void test_pi() {
		double area = Math.floor(Math.PI * Math.pow(10, 2));
		assertEquals(314, area, 0);
	}


	@Test
	public void test_sqrt() {
		double sroot = Math.sqrt(16);
		assertEquals(4, sroot, 0);
	}

	@Test
	public void test_log10() {
		double logV = Math.log10(100);
		assertEquals(2, logV, 0);
	}

	@Test
	public void test_sin() {
		assertEquals(0.5, Math.sin(60), 1);
	}

	@Test
	public void test_cos() {
		assertEquals(0.5, Math.cos(30), 1);
	}

	@Test
	public void test_log() {
		assertEquals(1, Math.log(Math.E), 0);
		assertEquals(2, Math.log(Math.pow(Math.E, 2)), 0);
		assertEquals(2, Math.log(Math.exp(2)), 0);
	}

	@Test
	public void test_constants() {
		System.out.println("Pi=" + Math.PI);
		System.out.println("E=" + Math.E);
	}

	@Test
	public void test_exp() {
		assertEquals(2, Math.log(Math.exp(2)), 0);
	}
}
