package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;

import org.junit.Test;

public class StringOperatorTest {

	@Test
	public void addition_concatenate_operator() {
		String msg1 = "Hello";
		String msg2 = " World!";

		assertEquals("Hello World!", msg1 + msg2);
	}

	@Test
	public void addition_concatenate_operator_hybrid() {
		int num = 10;
		String msg = "Hello ";
		assertEquals("Hello 10", msg + num);
	}

	@Test
	public void addition_concatenate_operator_hybrid_2() {
		String numStr = "10.00";
		String msg = "10.00 ";
		assertEquals("10.00 10.00", msg + numStr);
	}

	@Test
	public void mixer_constant() {
		//1, 2, 3 are constants
		assertEquals(6, 1 + 2 + 3);
		
		int one = 1;
		String three = "3";
		
		// 2 is the constant, so one+2 is 3
		assertEquals("33", one + 2 + three);
		assertNotEquals("123", one + 2 + three);
		assertEquals(6, 1 + 2 + 3);
	}

	@Test
	public void with_null() {
		String str1 = "Hello";
		String str2 = null;

		assertEquals("Hellonull", (str1 + str2)); // String str2 is null, the compiler replaces it will string null.
		assertNotEquals("Hello", str1 + str2);
	}

	@Test
	public void with_boolean() {
		String msg = "Hello world!";
		assertEquals("Hello world!true", msg + true);
		assertEquals("Hello world!false", msg + false);
	}
}