package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class AdditionOperatorTest {

	@Test
	public void byte_addition_arithmetic_operator() {
		byte b1 = 1;
		byte b2 = 2;

		byte sum = (byte) (b1 + b2);
		assertEquals(3, sum);

		// autoboxing
		Byte B1 = Byte.valueOf(b1);
		Byte B2 = Byte.valueOf(b2);
		assertEquals(3, B1 + B2);
	}

	@Test
	public void double_addition_arithmetic_operator() {
		double d1 = 10.01;
		double d2 = 20.05;

		double sum = d1 + d2;
		assertEquals(30.06, sum, 2);

		// autoboxing
		Double D1 = Double.valueOf(d1);
		Double D2 = Double.valueOf(d2);
		assertEquals(30.06, D1 + D2, 2);
	}

	@Test
	public void double_float() {
		double d = 12.234;
		float f = 10.1f;

		double sum = d + f;
		assertEquals(22.334, sum, 3);
	}

	@Test
	public void double_int() {
		double d = 12.234;
		int i = 10;

		double sum = d + i;
		assertEquals(22.234, sum, 3);
	}

	@Test
	public void float_addition_arithmetic_operator() {
		float num1 = 10.01f;
		float num2 = 20.05f;

		float sum = num1 + num2;
		assertEquals(30.06, sum, 2);

		// autoboxing
		Float F1 = Float.valueOf(num1);
		Float F2 = Float.valueOf(num2);
		assertEquals(30.06, F1 + F2, 2);
	}

	@Test
	public void float_int() {
		int i = 2;
		float f = 10.1f;

		float sum = i + f;
		assertEquals(12.1f, sum, 1);
	}

	@Test
	public void int_addition_arithmetic_operator() {
		int i = 10;
		int i2 = 20;

		int sum = i + i2;
		assertEquals(30, sum);

		Integer num1 = Integer.valueOf(i);
		Integer num2 = Integer.valueOf(i2);

		assertEquals(30, num1 + num2);
	}

	@Test
	public void long_addition_arithmetic_operator() {
		long num1 = 10;
		long num2 = 20;

		long sum = num1 + num2;
		assertEquals(30, sum);

		Long L1 = Long.valueOf(num1);
		Long L2 = Long.valueOf(num2);

		assertEquals(30, L1 + L2);
	}

	@Test
	public void long_int() {
		int i = 2;
		long l = 10000l;

		long sum = i + l;
		assertEquals(10002l, sum);
	}

	@Test
	public void short_addition_arithmetic_operator() {
		short s1 = 1;
		short s2 = 2;

		short sum = (short) (s1 + s2);
		assertEquals(3, sum);
	}

	@Test
	public void byte_add_constants() {
		byte sum = 1 + 2;
		// the operands 1 and 2 are constants.
		// the compiler computes the sum and replaces 1+2 as 3.
		assertEquals(3, sum);
	}

	@Test
	public void shorthand() {
		int i = 10;
		i += 7;

		assertEquals(17, i);
	}

}