package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class DivisionOperatorTest {

	@Test
	public void byte_division_arithmetic_operator() {
		byte num1 = 4;
		byte num2 = 2;

		byte division = (byte) (num1 / num2);
		assertEquals(2, division);
	}

	@Test
	public void byte_division_arithmetic_operator_2() {
		byte num1 = 4;
		byte num2 = 3;

		byte division = (byte) (num1 / num2);
		assertEquals(1, division);
	}

	@Test
	public void byte_division_arithmetic_operator_3() {
		byte num1 = 3;
		byte num2 = 4;

		byte division = (byte) (num1 / num2);
		assertEquals(0, division);
	}

	@Test
	public void double_division_arithmetic_operator() {
		double num1 = 10.02;
		double num2 = 3;

		double division = num1 / num2;
		assertEquals(3.34, division, 2);
	}

	@Test
	public void double_float() {
		double d = 12.234;
		float f = 10f;

		double division = d / f;
		assertEquals(1.223, division, 3);
	}

	@Test
	public void double_int() {
		double d = 12.234;
		int i = 10;

		double division = d / i;
		assertEquals(1.223, division, 3);
	}

	@Test
	public void float_division_arithmetic_operator() {
		float num1 = 10.02f;
		float num2 = 2f;

		float division = num1 / num2;
		assertEquals(5.01, division, 2);
	}

	@Test
	public void float_int() {
		int i = 2;
		float f = 10.1f;

		float division = f / i;
		assertEquals(5.05f, division, 2);
	}

	@Test
	public void int_division_arithmetic_operator() {
		int i = 40;
		int i2 = 20;

		int division = i / i2;
		assertEquals(2, division);
	}

	@Test
	public void long_division_arithmetic_operator() {
		long num1 = 60;
		long num2 = 20;

		long division = num1 / num2;
		assertEquals(3, division);
	}

	@Test
	public void long_int() {
		int i = 2;
		long l = 10000l;

		long division = l / i;
		assertEquals(5000l, division);
	}

	@Test
	public void short_division_arithmetic_operator() {
		short num1 = 1;
		short num2 = 2;

		short division = (short) (num1 / num2);
		assertEquals(0, division);
	}

	@Test
	public void byte_add_constants() {
		byte division = 1 / 2;
		assertEquals(0, division);
	}

	@Test
	public void shorthand() {
		int i = 10;
		i /= 2;

		assertEquals(5, i);
	}

	@Test
	public void test_Integer() {
		Integer num1 = Integer.valueOf(13);
		Integer num2 = Integer.valueOf(6);

		assertEquals(2, num1 / num2);
	}
}