package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;


public class MultiplicationOperatorTest {

	@Test
	public void byte_multiplication_arithmetic_operator() {
		byte num1 = 1;
		byte num2 = 2;

		byte product = (byte) (num1 * num2);
		assertEquals(2, product);
	}

	@Test
	public void double_multiplication_arithmetic_operator() {
		double num1 = 10.01;
		double num2 = 20.05;

		double product = num1 * num2;
		assertEquals(200.71, product, 2);
	}

	@Test
	public void double_float() {
		double d = 12.234;
		float f = 10.1f;
		
		double product = d * f;
		assertEquals(123.563, product, 3);
	}

	@Test
	public void double_int() {
		double d = 12.234;
		int i = 10;
		
		double product = d * i;
		assertEquals(122.234, product, 3);
	}

	@Test
	public void float_multiplication_arithmetic_operator() {
		float num1 = 10.01f;
		float num2 = 20.05f;

		float product = num1 * num2;
		assertEquals(200.71, product, 2);
	}

	@Test
	public void float_int() {
		int i = 2;
		float f = 10.1f;
		
		float product = i * f;
		assertEquals(20.2f, product, 1);
	}

	@Test
	public void int_multiplication_arithmetic_operator() {
		int i = 10;
		int i2 = 20;

		int product = i * i2;
		assertEquals(200, product);
	}
	
	@Test
	public void long_multiplication_arithmetic_operator() {
		long num1 = 10;
		long num2 = 20;

		long product = num1 * num2;
		assertEquals(200, product);
	}
	
	@Test
	public void long_int() {
		int i = 2;
		long l = 10000l;
		
		long product = i * l;
		assertEquals(20000l, product);
	}
	
	@Test
	public void short_multiplication_arithmetic_operator() {
		short num1 = 1;
		short num2 = 2;

		short product = (short) (num1 * num2);
		assertEquals(2, product);
	}
	
	@Test
	public void byte_add_constants() {
		byte product = 1 * 2;
		//the operands 1 and 2 are compile time constants. Therefore, the compiler computes the product as compile time and replaces 1*2 as 3.
		assertEquals(2, product);
	}
	
	@Test
	public void shorthand() {
		int i = 10;
		i *= 7;
		
		assertEquals(70, i);
	}
	
	@Test
	public void test_Integer() {
		Integer num1 = Integer.valueOf(5);
		Integer num2 = Integer.valueOf(6);
	 
		assertEquals(30, num1 * num2);
	}

}