package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;


public class RemainderOperatorTest {

	@Test
	public void byte_remainer_arithmetic_operator() {
		byte num1 = 1;
		byte num2 = 2;

		byte remainer = (byte) (num1 % num2);
		assertEquals(1, remainer);
	}

	@Test
	public void double_remainer_arithmetic_operator() {
		double num1 = 21;
		double num2 = 5;

		double remainer = num1 % num2;
		assertEquals(1, remainer, 2);
	}

	@Test
	public void double_float() {
		double d = 14;
		float f = 3f;

		double remainer = d % f;
		assertEquals(2, remainer, 0);
	}

	@Test
	public void double_int() {
		double d = 12.234;
		int i = 10;

		double remainer = d % i;
		assertEquals(2.234, remainer, 3);
	}

	@Test
	public void float_remainer_arithmetic_operator() {
		float num1 = 100f;
		float num2 = 20f;

		float remainer = num1 % num2;
		assertEquals(0, remainer, 2);
	}

	@Test
	public void float_int() {
		int i = 2;
		float f = 10.1f;

		float remainer = i % f;
		assertEquals(2f, remainer, 1);
	}

	@Test
	public void int_remainer_arithmetic_operator() {
		int i = 10;
		int i2 = 20;

		int remainer = i % i2;
		assertEquals(10, remainer);
	}

	@Test
	public void long_remainer_arithmetic_operator() {
		long num1 = 10;
		long num2 = 20;

		long remainer = num1 % num2;
		assertEquals(10, remainer);
	}

	@Test
	public void long_int() {
		int i = 2;
		long l = 10000l;

		long remainer = i % l;
		assertEquals(2, remainer);
	}

	@Test
	public void short_remainer_arithmetic_operator() {
		short num1 = 1;
		short num2 = 2;

		short remainer = (short) (num1 % num2);
		assertEquals(1, remainer);
	}

	@Test
	public void byte_add_constants() {
		byte remainer = 1 % 2;
		assertEquals(1, remainer);
	}

	@Test
	public void shorthand() {
		int i = 10;
		i %= 7;

		assertEquals(3, i);
	}
	
	@Test
	public void test_Integer() {
		Integer num1 = Integer.valueOf(5);
		Integer num2 = Integer.valueOf(6);
	 
		assertEquals(5, num1 % num2);
	}

}