package jcg.zheng.demo.mathoperator.relational;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import jcg.zheng.demo.data.POJO;
import jcg.zheng.demo.data.POJOHasEquals;

public class EqualsOperatorTest {

	@Test
	public void same_int_value_should_equalsto_eachother() {
		int i1 = 2;
		int i2 = 2;
		assertTrue(i1 == i2);
		assertFalse(i2 == 1);

		Integer num1 = Integer.valueOf(i1);
		Integer num2 = Integer.valueOf(i2);
		assertTrue(num1 == num2);
	}

	@Test
	public void same_byte_value_should_equalsto_eachother() {
		byte i1 = 2;
		byte i2 = 2;
		assertTrue(i1 == i2);
		assertFalse(i2 == 1);
	}

	@Test
	public void same_short_value_should_equalsto_eachother() {
		short i1 = 2;
		short i2 = 2;
		assertTrue(i1 == i2);
		assertFalse(i2 == 1);
	}

	@Test
	public void same_long_value_should_equalsto_eachother() {
		long i1 = 2;
		long i2 = 2;
		assertTrue(i1 == i2);
		assertFalse(i2 == 1);
	}

	@Test
	public void same_float_value_should_equalsto_eachother() {
		float i1 = 2.3f;
		float i2 = 2.3f;
		assertTrue(i1 == i2);

	}

	@Test
	public void same_double_value_should_equalsto_eachother() {
		double i1 = 20.0;
		double i2 = 20.00;
		assertTrue(i1 == i2);

	}

	@Test
	public void same_String_value_should_equalsto_eachother() {
		String s1 = "Mary";
		String s2 = "Mary";
		assertTrue(s1 == s2);
		assertTrue(s1.equals(s2));
	}

	@Test
	public void same_new_instance_of_POJO_not_equalsto_eachother() {
		POJO p1 = new POJO();
		POJO p2 = new POJO();
		assertFalse(p1 == p2);
		assertFalse(p1.equals(p2));
	}

	@Test
	public void same_new_instance_of_POJOHasEquals_not_equalsto_eachother() {
		POJOHasEquals p1 = new POJOHasEquals("Mary");
		POJOHasEquals p2 = new POJOHasEquals("Mary");
		assertFalse(p1 == p2);
		// Note because the overwrite equals. these two object return true from equals()
		assertTrue(p1.equals(p2));
	}
}
