package jcg.zheng.demo.mathoperator.relational;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import jcg.zheng.demo.data.POJO;
import jcg.zheng.demo.data.POJOHasEquals;

public class NotEqualsOperatorTest {

	@Test
	public void same_int_resutls_false_for_notequalsto_operator() {
		int i1 = 2;
		int i2 = 2;
		assertFalse(i1 != i2);
		assertFalse(i2 != 2);

		Integer num1 = Integer.valueOf(i1);
		Integer num2 = Integer.valueOf(i2);
		assertFalse(num1 != num2);
	}

	@Test
	public void same_byte_resutls_false_for_notequalsto_operator() {
		byte i1 = 2;
		byte i2 = 2;
		assertFalse(i1 != i2);
		assertTrue(i2 != 1);
	}

	@Test
	public void same_short_resutls_false_for_notequalsto_operator() {
		short i1 = 2;
		short i2 = 2;
		assertFalse(i1 != i2);
		assertTrue(i2 != 1);
	}

	@Test
	public void same_long_resutls_false_for_notequalsto_operator() {
		long i1 = 2;
		long i2 = 2;
		assertFalse(i1 != i2);
		assertTrue(i2 != 1);
	}

	@Test
	public void same_float_resutls_false_for_notequalsto_operator() {
		float i1 = 2.3f;
		float i2 = 2.3f;
		assertFalse(i1 != i2);

	}

	@Test
	public void same_double_resutls_false_for_notequalsto_operator() {
		double i1 = 20.0;
		double i2 = 20.00;
		assertFalse(i1 != i2);

	}

	@Test
	public void same_literal_String_resutls_false() {
		//liternal String are same if the values are same
		String s1 = "Mary";
		String s2 = "Mary";
		assertFalse(s1 != s2);
		
		//s3 uses new keyword, it will have a new instance
		String s3 = new String("Mary");
		assertTrue(s1 != s3);

	}

	@Test
	public void test_notequaltoOperator_POJO() {
		POJO p1 = new POJO();
		POJO p2 = new POJO();
		assertTrue(p1 != p2);

	}

	@Test
	public void test_notequaltoOperator_POJOHasEquals_default() {
		POJOHasEquals p1 = new POJOHasEquals();
		POJOHasEquals p2 = new POJOHasEquals();
		assertTrue(p1 != p2);

	}

	@Test
	public void test_notequaltoOperator_POJOHasEquals() {
		POJOHasEquals p1 = new POJOHasEquals("Mary");
		POJOHasEquals p2 = new POJOHasEquals("Mary");
		assertTrue(p1 != p2);
	}
}
